"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var plugin_exports = {};
__export(plugin_exports, {
  addToSchema: () => import_foundation_intermediate_representation.schema,
  plugin: () => plugin
});
module.exports = __toCommonJS(plugin_exports);
var import_assert = __toESM(require("assert"));
var import_foundation_parser = require("@code-like-a-carpenter/foundation-parser");
var import_graphql_codegen_helpers = require("@code-like-a-carpenter/graphql-codegen-helpers");
var import_config = require("./config");
var import_helpers = require("./helpers");
var import_blind_write = require("./tables/templates/blind-write");
var import_create_item = require("./tables/templates/create-item");
var import_delete_item = require("./tables/templates/delete-item");
var import_helpers2 = require("./tables/templates/helpers");
var import_marshall = require("./tables/templates/marshall");
var import_query = require("./tables/templates/query");
var import_read_item = require("./tables/templates/read-item");
var import_unmarshall = require("./tables/templates/unmarshall");
var import_update_item = require("./tables/templates/update-item");
var import_foundation_intermediate_representation = require("@code-like-a-carpenter/foundation-intermediate-representation");
const plugin = (0, import_graphql_codegen_helpers.makePlugin)(
  import_config.ConfigSchema,
  (schema2, documents, config, info) => {
    try {
      const { additionalImports, dependenciesModuleId, tables, models } = (0, import_foundation_parser.parse)(
        schema2,
        documents,
        config,
        info
      );
      const content = `


${models.map((model) => {
        const hasPublicIdInPrimaryKey = model.primaryKey.partitionKeyFields.some(
          (field) => field.fieldName === "publicId"
        ) || ("sortKeyFields" in model.primaryKey ? model.primaryKey.sortKeyFields.some(
          (field) => field.fieldName === "publicId"
        ) : false);
        if (hasPublicIdInPrimaryKey) {
          console.warn(
            `Model ${model.typeName} has a publicId in its primary key and therefore blindWrite is not supported.`
          );
        }
        return [
          `export interface ${model.typeName}PrimaryKey ${(0, import_helpers2.objectToString)(
            Object.fromEntries(
              (model.primaryKey.isComposite ? [
                ...model.primaryKey.partitionKeyFields,
                ...model.primaryKey.sortKeyFields
              ] : model.primaryKey.partitionKeyFields).map(import_helpers2.getTypeScriptTypeForField).sort()
            )
          )}`,
          (0, import_create_item.createItemTemplate)(config, model),
          !model.isLedger && !hasPublicIdInPrimaryKey && (0, import_blind_write.blindWriteTemplate)(config, model),
          !model.isLedger && (0, import_delete_item.deleteItemTemplate)(config, model),
          (0, import_read_item.readItemTemplate)(config, model),
          !model.isLedger && (0, import_update_item.updateItemTemplate)(config, model),
          (0, import_query.queryTemplate)(model),
          (0, import_marshall.marshallTpl)(config, model),
          (0, import_unmarshall.unmarshallTpl)(model)
        ].filter(import_helpers.filterNull).join("\n\n");
      }).join("\n")}`;
      (0, import_assert.default)(info?.outputFile, "info.outputFile is required");
      const runtimeModuleId = "@code-like-a-carpenter/foundation-runtime";
      const hasPublicModels = tables.some((table) => table.hasPublicModels);
      const importFromDependencies = [
        "ddbDocClient",
        hasPublicModels && "idGenerator"
      ].filter(import_helpers.filterNull).join(", ");
      return {
        content,
        prepend: [
          `import {AssertionError} from 'node:assert';`,
          `import {ConditionalCheckFailedException} from '@aws-sdk/client-dynamodb';`,
          `import {
            DeleteCommand,
            DeleteCommandInput,
            GetCommand,
            GetCommandInput,
            QueryCommand,
            QueryCommandInput,
            UpdateCommand,
            UpdateCommandInput
          } from '@aws-sdk/lib-dynamodb';`,
          `import {ServiceException} from '@aws-sdk/smithy-client';`,
          `import {NativeAttributeValue} from '@aws-sdk/util-dynamodb';`,
          `import Base64 from 'base64url';`,
          `import {assert} from '@code-like-a-carpenter/assert';`,
          `import {
            makeSortKeyForQuery,
            unmarshallRequiredField,
            unmarshallOptionalField,
            AlreadyExistsError,
            BaseDataLibraryError,
            DataIntegrityError,
            MultiResultType,
            NotFoundError,
            OptimisticLockingError,
            ResultType,
            QueryOptions,
            UnexpectedAwsError,
            UnexpectedError
          } from '${runtimeModuleId}';`,
          `import {${importFromDependencies}} from "${dependenciesModuleId}";`,
          ...additionalImports.map(
            ({ importName, importPath }) => `import {${importName}} from '${importPath}';`
          )
        ]
      };
    } catch (err) {
      console.error(err);
      throw err;
    }
  }
);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  addToSchema,
  plugin
});
