"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var computed_fields_exports = {};
__export(computed_fields_exports, {
  defineComputedInputFields: () => defineComputedInputFields,
  defineComputedOutputFields: () => defineComputedOutputFields,
  hasComputedFields: () => hasComputedFields,
  inputName: () => inputName
});
module.exports = __toCommonJS(computed_fields_exports);
var import_assert = __toESM(require("assert"));
function hasComputedFields(model) {
  return model.fields.some((field) => !!field.computeFunction);
}
function inputName(model) {
  return hasComputedFields(model) ? "_input" : "input";
}
function defineComputedInputFields(fields, typeName) {
  const computedFields = fields.filter(({ computeFunction }) => !!computeFunction).map((field) => {
    const { fieldName, computeFunction } = field;
    (0, import_assert.default)(computeFunction);
    const { importName } = computeFunction;
    return `const ${fieldName}Provider = new ${importName}();

        Object.defineProperty(input, '${fieldName}', {
          enumerable: true,
          /** getter */
          get() {
            return ${fieldName}Provider.compute(this);
          }
        })`;
  }).join("\n");
  if (computedFields) {
    return `
      // This has to be cast because we're adding computed fields on the next
      // lines.
      const input: Marshall${typeName}Input = {..._input} as Marshall${typeName}Input
      ${computedFields}
    `;
  }
  return "";
}
function defineComputedOutputFields(fields) {
  return fields.filter(({ computeFunction }) => !!computeFunction).map((field) => {
    const { fieldName, computeFunction } = field;
    (0, import_assert.default)(computeFunction);
    const { importName } = computeFunction;
    return `
        const ${fieldName}Provider = new ${importName}();

        Object.defineProperty(result, '${fieldName}', {
          enumerable: true,
          /** getter */
          get() {
            return ${fieldName}Provider.compute(this);
          }
        })
      `;
  }).join("\n");
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  defineComputedInputFields,
  defineComputedOutputFields,
  hasComputedFields,
  inputName
});
