import { z } from 'zod';
export declare const ConfigSchema: z.ZodObject<{
    actionsModuleId: z.ZodString;
    dependenciesModuleId: z.ZodString;
    dispatcherDefaults: z.ZodDefault<z.ZodObject<{
        memorySize: z.ZodDefault<z.ZodNumber>;
        timeout: z.ZodDefault<z.ZodNumber>;
        batchSize: z.ZodDefault<z.ZodNumber>;
        maximumRetryAttempts: z.ZodDefault<z.ZodNumber>;
    }, "strip", z.ZodTypeAny, {
        memorySize: number;
        timeout: number;
        batchSize: number;
        maximumRetryAttempts: number;
    }, {
        memorySize?: number | undefined;
        timeout?: number | undefined;
        batchSize?: number | undefined;
        maximumRetryAttempts?: number | undefined;
    }>>;
    handlerDefaults: z.ZodDefault<z.ZodObject<{
        memorySize: z.ZodDefault<z.ZodNumber>;
        timeout: z.ZodDefault<z.ZodNumber>;
    }, "strip", z.ZodTypeAny, {
        memorySize: number;
        timeout: number;
    }, {
        memorySize?: number | undefined;
        timeout?: number | undefined;
    }>>;
    lambdaDefaults: z.ZodDefault<z.ZodObject<{
        memorySize: z.ZodDefault<z.ZodNumber>;
        timeout: z.ZodDefault<z.ZodNumber>;
    }, "strip", z.ZodTypeAny, {
        memorySize: number;
        timeout: number;
    }, {
        memorySize?: number | undefined;
        timeout?: number | undefined;
    }>>;
    tableDefaults: z.ZodDefault<z.ZodObject<{
        enablePointInTimeRecovery: z.ZodDefault<z.ZodBoolean>;
    }, "strip", z.ZodTypeAny, {
        enablePointInTimeRecovery: boolean;
    }, {
        enablePointInTimeRecovery?: boolean | undefined;
    }>>;
    useEfficientIndexes: z.ZodDefault<z.ZodBoolean>;
    legacyEmptySortFieldBehavior: z.ZodDefault<z.ZodBoolean>;
}, "strip", z.ZodTypeAny, {
    actionsModuleId: string;
    dependenciesModuleId: string;
    dispatcherDefaults: {
        memorySize: number;
        timeout: number;
        batchSize: number;
        maximumRetryAttempts: number;
    };
    handlerDefaults: {
        memorySize: number;
        timeout: number;
    };
    lambdaDefaults: {
        memorySize: number;
        timeout: number;
    };
    tableDefaults: {
        enablePointInTimeRecovery: boolean;
    };
    useEfficientIndexes: boolean;
    legacyEmptySortFieldBehavior: boolean;
}, {
    actionsModuleId: string;
    dependenciesModuleId: string;
    dispatcherDefaults?: {
        memorySize?: number | undefined;
        timeout?: number | undefined;
        batchSize?: number | undefined;
        maximumRetryAttempts?: number | undefined;
    } | undefined;
    handlerDefaults?: {
        memorySize?: number | undefined;
        timeout?: number | undefined;
    } | undefined;
    lambdaDefaults?: {
        memorySize?: number | undefined;
        timeout?: number | undefined;
    } | undefined;
    tableDefaults?: {
        enablePointInTimeRecovery?: boolean | undefined;
    } | undefined;
    useEfficientIndexes?: boolean | undefined;
    legacyEmptySortFieldBehavior?: boolean | undefined;
}>;
export type Config = z.infer<typeof ConfigSchema>;
export type InputConfig = z.input<typeof ConfigSchema>;
//# sourceMappingURL=config.d.ts.map