import type { Field, PrimaryKeyConfig } from '@code-like-a-carpenter/foundation-intermediate-representation';
import type { Config } from '../../config';
/** Gets the TypeScript type for that corresponds to the field. */
export declare function getTypeScriptTypeForField({ fieldName, isRequired, isScalarType: isScalar, typeName, }: Field): [string, string];
/**
 * Marshalls the specified field value for use with ddb.
 */
export declare function marshallField({ columnName, fieldName, isDateType, }: Field): string;
/** Generates the template for producing the desired primary key or index column */
export declare function makeKeyTemplate(prefix: string | undefined, fields: readonly Field[], mode: 'blind' | 'create' | 'read'): string;
/** Converts a compile time object to a runtime object */
export declare function objectToString(obj: Record<string, string>): string;
/**
 * Helper function for building a field unmarshaller
 */
export declare function unmarshallFieldValue(field: Field): string;
/**
 * Helper function for building a field unmarshaller
 */
export declare function unmarshallField(field: Field): string;
export declare function handleCommonErrors(): string;
export declare function makeKeyForRead(config: Config, key: PrimaryKeyConfig): Record<string, string>;
//# sourceMappingURL=helpers.d.ts.map